
/* -- Z80 Disassembler for Avocet compiler (v1.0) -- */

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <process.h>
#include <fcntl.h>
#include <sys\stat.h>

#define negative(x) ((-(x))&0xFF)

#define IX 1
#define IY 2
#define CB 3
#define ED 4

void main (int argc,char *argv[])
  {
  char *Cond[]  = {"NZ","Z","NC","C","PO","PE","P","M"};
  char *RstN[]  = {"00h","08h","10h","18h","20h","28h","30h","38h"};
  char *RegB[]  = {"B","C","D","E","H","L","(HL)","A"};
  char *RegBX[] = {"B","C","D","E","HX","LX","__","A"};
  char *RegBY[] = {"B","C","D","E","HY","LY","__","A"};
  char *RegW1[] = {"BC","DE","HL","SP"};
  char *RegW2[] = {"BC","DE","HL","AF"};
  char *RegIW[] = {"HL","IX","IY"};
  char *RegIH[] = {"H","HX","HY"};
  char *RegIL[] = {"L","LX","LY"};

  char *oper,disp[8],text[80],file_out[15];
  FILE *file_bin,*fz80,*ftxt;
  int  addr,AdrBeg=0,hl,ch,dat8,datl,dath,dat16;
  int  label[1000],ind_lbl,pass,i,k,ladr,ind_now;
  int  fcomp(unsigned int*,unsigned int*);
  int  tnum;
  int  tbeg[100],tend[100];

  for (i=0;i<100;i++) {tbeg[i]=0x7FFF; tend[i]=0x7FFF;}

  strnset(file_out,0,15);

  if (argc!=3)
    {
    printf ("\nBad arguments\n");
    exit(1) ;
    }

  file_bin=fopen(argv[1],"rb");
  if (file_bin==NULL)
    {
    printf ("\n Can't open file %s ",argv[2]);
    perror("");
    exit(1);
    }
  strncpy (file_out,argv[1],strcspn(argv[1],"."));
  strcat (file_out+strcspn(argv[1],"."),".dis");

  ftxt=fopen(argv[2],"rt");
  if (ftxt==NULL)
    {
    printf ("\n Can't open file %s ",argv[2]);
    perror("");
    exit(1);
    }

  for (i=0;feof(ftxt)==0;i++)  fscanf (ftxt,"%x%x",&(tbeg[i]),&(tend[i]));

  tnum=i;

  fz80=fopen (file_out,"wt");

  if (fz80==NULL)
    {
    printf ("\n Can't creat file %s ",file_out);
    perror("");
    exit(1);
    }

/* --------- MAIN BLOCK --------- */

  ind_lbl=0;

for(pass=0;pass<2;pass++)
  {
  rewind(file_bin);
  addr=AdrBeg;
  hl=0;
  ind_now=0;

  for (;;)
    {
    ladr=addr;

    if ((ch=getc(file_bin))==EOF) goto end;

    for (i=0;i<tnum;i++)
      {
      if (ladr>=tbeg[i] && ladr<=tend[i])
        {
        if (isprint(ch))  sprintf (text,"DB\t%03Xh ; \'%c\'",ch,ch);
          else sprintf (text,"DB\t%03Xh",ch);
        goto oprend;
        }
      }

    if (ch==0xDD) hl=IX;
    if (ch==0xFD) hl=IY;

    if (hl)
      {
      addr++; if ((ch=getc(file_bin))==EOF) goto end;
      }

/* -------- ED prefix ------- */

    if (ch==0xED)
      {
      addr++; if ((ch=getc(file_bin))==EOF) goto end;

      switch (ch)
	{
	case 0x57: { strcpy(text,"LD\tA,I");goto oprend;}
	case 0x5F: { strcpy(text,"LD\tA,R");goto oprend;}
	case 0x47: { strcpy(text,"LD\tI,A");goto oprend;}
	case 0x4F: { strcpy(text,"LD\tR,A");goto oprend;}
	case 0xA0: { strcpy(text,"LDI");goto oprend;}
	case 0xB0: { strcpy(text,"LDIR");goto oprend;}
	case 0xA8: { strcpy(text,"LDD");goto oprend;}
	case 0xB8: { strcpy(text,"LDDR");goto oprend;}
	case 0xA1: { strcpy(text,"CPI");goto oprend;}
	case 0xB1: { strcpy(text,"CPIR");goto oprend;}
	case 0xA9: { strcpy(text,"CPD");goto oprend;}
	case 0xB9: { strcpy(text,"CPDR");goto oprend;}
	case 0xA2: { strcpy(text,"INI");goto oprend;}
	case 0xB2: { strcpy(text,"INIR");goto oprend;}
	case 0xAA: { strcpy(text,"IND");goto oprend;}
	case 0xBA: { strcpy(text,"INDR");goto oprend;}
	case 0xA3: { strcpy(text,"OUTI");goto oprend;}
	case 0xB3: { strcpy(text,"OTIR");goto oprend;}
	case 0xAB: { strcpy(text,"OUTD");goto oprend;}
	case 0xBB: { strcpy(text,"OTDR");goto oprend;}
	case 0x44: { strcpy(text,"NEG");goto oprend;}
	case 0x46: { strcpy(text,"IM\t0");goto oprend;}
	case 0x56: { strcpy(text,"IM\t1");goto oprend;}
	case 0x5E: { strcpy(text,"IM\t2");goto oprend;}
	case 0x6F: { strcpy(text,"RLD");goto oprend;}
	case 0x67: { strcpy(text,"RRD");goto oprend;}
	case 0x4D: { strcpy(text,"RETI");goto oprend;}
	case 0x45: { strcpy(text,"RETN");goto oprend;}
	}
      if ((ch&0xC7)==0x42)
	{
	if (ch & 0x08) oper="ADC\tHL,"; else oper="SBC\tHL,";
	sprintf(text,"%s%s",oper,RegW1[(ch>>4)&3]);
	goto oprend;
	}
      if ((ch&0xC7)==0x40)
	{
	sprintf(text,"IN\t%s,(C)",RegB[(ch>>3)&7]);
	goto oprend;
	}
      if ((ch&0xC7)==0x41)
	{
	sprintf(text,"OUT\t(C),%s",RegB[(ch>>3)&7]);
	goto oprend;
	}
      if ((ch&0xC7)==0x43)
	{
        addr++; if ((datl=getc(file_bin))==EOF) goto end;
        addr++; if ((dath=getc(file_bin))==EOF) goto end;
        dat16=(dath<<8)|datl;

        if (ch & 0x08) sprintf(text,"LD\t%s,(%05Xh)",RegW1[(ch>>4)&3],dat16);
	  else	sprintf(text,"LD\t(%05Xh),%s",dat16,RegW1[(ch>>4)&3]);
        goto oprend;
	}
      sprintf(text,"DB\t0EDh,%03Xh",ch);
      goto oprend;
      }

/* ------- CB prefix ---------- */

    if (ch==0xCB)
      {
      addr++; if((ch=getc(file_bin))==EOF) goto end;

      if (hl!=0)
	{
	dat8=ch;
	addr++;  if ((ch=getc(file_bin))==EOF) goto end;

        if (dat8<=0x7F) sprintf (disp,"+%02Xh\0",dat8);
          else sprintf (disp,"-%02Xh\0",negative(dat8));
	}
      if (ch<0x40)
	{
	switch(ch & 0xF8)
	  {
	  case 0x00: {oper="RLC"; break;}
	  case 0x08: {oper="RRC"; break;}
	  case 0x10: {oper="RL" ; break;}
	  case 0x18: {oper="RR" ; break;}
	  case 0x20: {oper="SLA"; break;}
	  case 0x28: {oper="SRA"; break;}
	  case 0x30: {oper="SLI"; break;}
	  case 0x38: {oper="SRL"; break;}
	  }
	if (hl==0) sprintf(text,"%s\t%s",oper,RegB[ch&7]);
	else
	  {
	  if ((ch&7)==6)
	    {
	    sprintf(text,"%s\t(%s%s)",oper,RegIW[hl],disp);
	    }
	  else
	    {
	    sprintf(text,"%s\t(%s%s),%s",oper,RegIW[hl],disp,RegB[ch&7]);
	    }
	  }
	}
      else
	{
	switch (ch & 0xC0)
	  {
	  case 0x40: {oper="BIT"; break;}
	  case 0x80: {oper="RES"; break;}
	  case 0xC0: {oper="SET"; break;}
	  }
	if (hl==0) sprintf(text,"%s\t%1d,%s",oper,(ch>>3)&7,RegB[ch&7]);
	else
	  {
	  if ((ch&7)==6)
	    {
	    sprintf(text,"%s\t%1d,(%s%s)",oper,(ch>>3)&7,RegIW[hl],disp);
	    }
	  }
	}
      goto oprend;
      }

/* ------- One byte special --------- */

    switch (ch)
      {
      case 0x00: { strcpy(text,"NOP");        goto oprend;}
      case 0x07: { strcpy(text,"RLCA");       goto oprend;}
      case 0x08: { strcpy(text,"EX\tAF,AF\'");goto oprend;}
      case 0x0F: { strcpy(text,"RRCA");       goto oprend;}
      case 0x17: { strcpy(text,"RLA");        goto oprend;}
      case 0x1F: { strcpy(text,"RRA");        goto oprend;}
      case 0x27: { strcpy(text,"DAA");        goto oprend;}
      case 0x2F: { strcpy(text,"CPL");        goto oprend;}
      case 0x37: { strcpy(text,"SCF");        goto oprend;}
      case 0x3F: { strcpy(text,"CCF");        goto oprend;}
      case 0x76: { strcpy(text,"HALT");       goto oprend;}
      case 0xC9: { strcpy(text,"RET");        goto oprend;}
      case 0xD9: { strcpy(text,"EXX");        goto oprend;}
      case 0xEB: { strcpy(text,"EX\tDE,HL");  goto oprend;}
      case 0xF3: { strcpy(text,"DI");         goto oprend;}
      case 0xFB: { strcpy(text,"EI");         goto oprend;}
      case 0x02: { strcpy(text,"LD\t(BC),A"); goto oprend;}
      case 0x0A: { strcpy(text,"LD\tA,(BC)"); goto oprend;}
      case 0x12: { strcpy(text,"LD\t(DE),A"); goto oprend;}
      case 0x1A: { strcpy(text,"LD\tA,(DE)"); goto oprend;}
      }
    if (ch==0xE3)
      {
      sprintf(text,"EX\t(SP),%s",RegIW[hl]);
      goto oprend;
      }


/* ------- INC/DEC hl,h,l,ix,iy,hx,lx,hy,ly -------- */

    switch (ch)
      {
      case 0x23: { sprintf(text,"INC\t%s",RegIW[hl]); goto oprend;}
      case 0x2B: { sprintf(text,"DEC\t%s",RegIW[hl]); goto oprend;}
      case 0x24: { sprintf(text,"INC\t%s",RegIH[hl]); goto oprend;}
      case 0x25: { sprintf(text,"DEC\t%s",RegIH[hl]); goto oprend;}
      case 0x2C: { sprintf(text,"INC\t%s",RegIL[hl]); goto oprend;}
      case 0x2D: { sprintf(text,"DEC\t%s",RegIL[hl]); goto oprend;}

      case 0xE9: { sprintf(text,"JP\t(%s)",RegIW[hl]); goto oprend;}
      case 0xF9: { sprintf(text,"LD\tSP,%s",RegIW[hl]); goto oprend;}
      }

    if (((ch & 0xFE)==0x34)&& hl)
      {
      addr++; if ((dat8=getc(file_bin))==EOF) goto end;

      if (dat8<=0x7F) sprintf (disp,"+%02Xh\0",dat8);
        else sprintf (disp,"-%02Xh\0",negative(dat8));

      if (ch & 1) sprintf(text,"DEC\t(%s%s)",RegIW[hl],disp);
        else sprintf(text,"INC\t(%s%s)",RegIW[hl],disp);
      goto oprend;
      }

    if ((ch & 0xC6)==0x04)
      {
      if (ch&1) oper="DEC"; else oper="INC";

      sprintf(text,"%s\t%s",oper,RegB[(ch>>3)&7]);
      goto oprend;
      }

    if ((ch & 0xC7)==0x03)
      {
      if (ch&8) oper="DEC"; else oper="INC";

      sprintf(text,"%s\t%s",oper,RegW1[(ch>>4)&3]);
      goto oprend;
      }

/* ------ ADD HL,__ IX,__ IY,__ ------ */

    if (ch==0x29)
      {
      sprintf(text,"ADD\t%s,%s",RegIW[hl],RegIW[hl]);
      goto oprend;
      }
    if ((ch & 0xCF)==0x09)
      {
      sprintf(text,"ADD\t%s,%s",RegIW[hl],RegW1[(ch>>4)&3]);
      goto oprend;
      }

/* ------ IN & OUT --------- */

    if((ch & 0xF7)==0xD3)
      {
      addr++; if ((dat8=getc(file_bin))==EOF) goto end;

      if (ch & 8) sprintf(text,"IN\tA,(0%02Xh)",dat8);
        else sprintf(text,"OUT\t(0%02Xh),A",dat8);
      goto oprend;
      }

/* -------- LD 16-bit addr --------- */

    if ((ch & 0xE7)==0x22)
      {
      addr++; if ((datl=getc(file_bin))==EOF) goto end;
      addr++; if ((dath=getc(file_bin))==EOF) goto end;
      dat16=(dath<<8)|datl;

      switch (ch)
        {
        case 0x22: {sprintf(text,"LD\t(0%04Xh),%s",dat16,RegIW[hl]);break;}
        case 0x2A: {sprintf(text,"LD\t%s,(0%04Xh)",RegIW[hl],dat16);break;}
        case 0x32: {sprintf(text,"LD\t(0%04Xh),A",dat16);break;}
        case 0x3A: {sprintf(text,"LD\tA,(0%04Xh)",dat16);break;}
        }
      goto oprend;
      }

    if((ch & 0xCF)==0x01)
      {
      addr++; if ((datl=getc(file_bin))==EOF) goto end;
      addr++; if ((dath=getc(file_bin))==EOF) goto end;
      dat16=(dath<<8)|datl;

      if (hl) sprintf(text,"LD\t%s,0%04Xh",RegIW[hl],dat16);
        else sprintf(text,"LD\t%s,0%04Xh",RegW1[(ch>>4)&3],dat16);

      goto oprend;
      }

/* -------- LD 8-bit dat8 --------- */

    if ((ch & 0xC7)==0x06)
      {
      addr++; if ((dat8=getc(file_bin))==EOF) goto end;

      if (hl && ch==0x36)
        {
        if (dat8<=0x7F) sprintf (disp,"+%02Xh\0",dat8);
          else sprintf (disp,"-%02Xh\0",negative(dat8));

        addr++; if ((dat8=getc(file_bin))==EOF) goto end;

        sprintf(text,"LD\t(%s%s),%03Xh",RegIW[hl],disp,dat8);
        goto oprend;
        }
      if (ch==0x26 && hl)
        {
        sprintf(text,"LD\t%s,%03X",RegIH[hl],dat8);
        }
      if (ch==0x2E && hl)
        {
        sprintf(text,"LD\t%s,%03X",RegIL[hl],dat8);
        }
      sprintf(text,"LD\t%s,%03Xh",RegB[(ch>>3)&7],dat8);
      goto oprend;
      }

/* -------- LD 8-bit registers --------- */

    if (((ch & 0xF8)==0x70)&& hl)
      {
      addr++; if ((dat8=getc(file_bin))==EOF) goto end;

      if (dat8<=0x7F) sprintf (disp,"+%02Xh\0",dat8);
        else sprintf (disp,"-%02Xh\0",negative(dat8));

      sprintf(text,"LD\t(%s%s),%s",RegIW[hl],disp,RegB[ch&7]);
      goto oprend;
      }

    if (((ch & 0xC7)==0x46)&& hl)
      {
      addr++; if ((dat8=getc(file_bin))==EOF) goto end;

      if (dat8<=0x7F) sprintf (disp,"+%02Xh\0",dat8);
        else sprintf (disp,"-%02Xh\0",negative(dat8));

      sprintf(text,"LD\t%s,(%s%s)",RegB[(ch>>3)&7],RegIW[hl],disp);
      goto oprend;
      }
    if (ch>=0x40 && ch<=0x7F)
      {
      if (hl==IX) {sprintf(text,"LD\t%s,%s",RegBX[(ch>>3)&7],RegBX[ch&7]); goto oprend;}
      if (hl==IY) {sprintf(text,"LD\t%s,%s",RegBY[(ch>>3)&7],RegBY[ch&7]); goto oprend;}
      sprintf(text,"LD\t%s,%s",RegB[(ch>>3)&7],RegB[ch&7]);
      goto oprend;
      }

/* -------- 8-bit Ariphmetic  --------- */

    if (ch>=0x80 && ch<=0xBF)
      {
      switch (ch&0xF8)
        {
        case 0x80 : {oper="ADD\tA,";break;}
        case 0x88 : {oper="ADC\tA,";break;}
        case 0x90 : {oper="SUB\t";break;}
        case 0x98 : {oper="SBC\tA,";break;}
        case 0xA0 : {oper="AND\t";break;}
        case 0xA8 : {oper="XOR\t";break;}
        case 0xB0 : {oper="OR\t";break;}
        case 0xB8 : {oper="CP\t";break;}
        }
      if (((ch & 0xC7)==0x86)&& hl)
        {
        addr++; if ((dat8=getc(file_bin))==EOF) goto end;

        if (dat8<=0x7F) sprintf (disp,"+%02Xh\0",dat8);
          else sprintf (disp,"-%02Xh\0",negative(dat8));

        sprintf(text,"%s(%s%s)",oper,RegIW[hl],disp);
        goto oprend;
        }


      if (hl==IX) {sprintf(text,"%s%s",oper,RegBX[ch&0x07]); goto oprend;}
      if (hl==IY) {sprintf(text,"%s%s",oper,RegBY[ch&0x07]); goto oprend;}
      sprintf(text,"%s%s",oper,RegB[ch&0x07]);
      goto oprend;
      }

    if ((ch & 0xC7)==0xC6)
      {
      switch (ch)
        {
        case 0xC6 : {oper="ADD\tA,";break;}
        case 0xCE : {oper="ADC\tA,";break;}
        case 0xD6 : {oper="SUB\t";break;}
        case 0xDE : {oper="SBC\tA,";break;}
        case 0xE6 : {oper="AND\t";break;}
        case 0xEE : {oper="XOR\t";break;}
        case 0xF6 : {oper="OR\t";break;}
        case 0xFE : {oper="CP\t";break;}
        }
      addr++; if ((dat8=getc(file_bin))==EOF) goto end;

      sprintf(text,"%s%03Xh",oper,dat8);
      goto oprend;
      }

/* ------- JR<cond>,DJNZ --- ****** ---- */

    if (ch==0x10||ch==0x18)
      {
      addr++; if ((dat8=getc(file_bin))==EOF) goto end;

      if (ch&8) oper="JR"; else oper="DJNZ";

      if (dat8<=0x7F) dat16=(addr+1)+dat8;
        else  dat16=(addr+1)-negative(dat8);

      if (pass==0) label[ind_lbl++]=dat16;

      sprintf(text,"%s\tL_%04X",oper,dat16);
      goto oprend;
      }

    if ((ch & 0xE7)==0x20)
      {
      addr++; if ((dat8=getc(file_bin))==EOF) goto end;

      if (dat8<=0x7F) dat16=(addr+1)+dat8;
        else  dat16=(addr+1)-negative(dat8);

      if (pass==0) label[ind_lbl++]=dat16;

      sprintf(text,"JR\t%s,L_%04X",Cond[(ch>>3)&3],dat16);
      goto oprend;
      }

/* ------- JP<cond>,CALL<cond>,RET ------- */

    if (ch==0xC3||ch==0xCD)
      {
      addr++; if ((datl=getc(file_bin))==EOF) goto end;
      addr++; if ((dath=getc(file_bin))==EOF) goto end;
      dat16=(dath<<8)|datl;

      if (ch & 0x08) oper="CALL"; else oper="JP";

      if (pass==0) label[ind_lbl++]=dat16;

      sprintf(text,"%s\tL_%04X",oper,dat16);
      goto oprend;
      }

    if ((ch & 0xC7)==0xC4||(ch&0xC7)==0xC2)
      {
      addr++; if ((datl=getc(file_bin))==EOF) goto end;
      addr++; if ((dath=getc(file_bin))==EOF) goto end;
      dat16=(dath<<8)|datl;

      if (ch&4) oper="CALL"; else oper="JP";

      if (pass==0) label[ind_lbl++]=dat16;

      sprintf(text,"%s\t%s,L_%04X",oper,Cond[(ch>>3)&7],dat16);
      goto oprend;
      }

    if ((ch & 0xC7)==0xC0)
      {
      sprintf(text,"RET\t%s",Cond[(ch>>3)&7]);
      goto oprend;
      }

    if ((ch & 0xC7)==0xC7)
      {
      sprintf(text,"RST\t%s",RstN[(ch>>3)&7]);
      goto oprend;
      }

/* ------ PUSH & POP ------ */

   if (ch==0xE1)
     {
     sprintf(text,"POP\t%s",RegIW[hl]);
     goto oprend;
     }

   if (ch==0xE5)
     {
     sprintf(text,"PUSH\t%s",RegIW[hl]);
     goto oprend;
     }

   if ((ch & 0xCF)==0xC1)
     {
     sprintf(text,"POP\t%s",RegW2[(ch>>4)&3]);
     goto oprend;
     }

   if ((ch & 0xCF)==0xC5)
     {
     sprintf(text,"PUSH\t%s",RegW2[(ch>>4)&3]);
     goto oprend;
     }

/* ---- */

  oprend:
    addr++;

    if (pass)
      {
      fprintf(fz80,"%04X ",ladr);
      k=addr-ladr;
      fseek(file_bin,-((long)k),SEEK_CUR);
      for(i=k;i>0;i--)
        {
        fprintf(fz80," %02X",getc(file_bin));
        }
      if (k<=3) putc('\t',fz80);
      fputs (".\t",fz80);

      while(label[ind_now]<ladr) ind_now++;

      if (label[ind_now]==ladr) fprintf(fz80,"L_%04X:\t%s\n",ladr,text);
        else fprintf(fz80,"\t%s\n",text);
      }

    hl=0;

    if ((addr%100)>=0 && (addr%100)<=3)
      {
      gotoxy(2,wherey());
      printf("Address %5d  index = %d",(addr/100)*100,ind_lbl);
      }
    }

/* ------------------------- */

end:
  if (pass==0) qsort(label,ind_lbl,2,fcomp);

  gotoxy(2,wherey());
  printf("  Pass %d finished               \n",pass);
  }

/* ------------------------- */

  fputs("\n\t\t\t\tEND\n\n",fz80);
  puts ("\n");
  exit(0);
  }

int fcomp(unsigned int*a,unsigned int*b)
  {
  if (*a<*b) return -1;
  if (*a==*b) return 0;
  return 1;
  }









